<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
  <title>Device Configuration</title>

  <link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

  <script src='../js/meti_merged.js'></script>
  <script src='../js/meti_utils.js'></script>

  <style>
    #main_body {
      visibility: hidden;
    }

    label {
      margin-bottom: 0px;
    }

    .custom-checkbox {
      min-height: 1rem;
    }

    .show_later {
      visibility: hidden;
    }

    #registration_status {
      color: red;
      font-size: medium;
      visibility: hidden;
    }
  </style>

</head>


<body>
  <div id="main_body">
    <div w3-include-html="meti_bst.html"></div>

    <div class="container">
      <div class="row">
        <h5 class="pt-1 mb-1">Device Configuration<span id="registration_status" class="m-1">(Unregistered)</span>
        </h5>
        <main role="main" class="col-12 pt-1">
          <form id="formID">
            <ul class="nav nav-pills mb-1" id="pills-tab" role="tablist">
              <li class="nav-item" role="presentation">
                <a class="nav-link active" id="pills-params-tab" data-toggle="pill" href="#pills-params" role="tab"
                  aria-controls="pills-params" aria-selected="true">Parameters</a>
              </li>
              <li class="nav-item" role="presentation">
                <a class="nav-link" id="pills-live-tab" data-toggle="pill" href="#pills-live" role="tab"
                  aria-controls="pills-live" aria-selected="false">METI Live</a>
              </li>
              <li class="nav-item" role="presentation">
                <a class="nav-link" id="pills-mqtt-tab" data-toggle="pill" href="#pills-mqtt" role="tab"
                  aria-controls="pills-mqtt" aria-selected="false">MQTT</a>
              </li>
            </ul>
            <div class="tab-content" id="pills-tabContent">
              <!-- Parameters -->
              <div class="tab-pane fade show active" id="pills-params" role="tabpanel"
                aria-labelledby="pills-params-tab">
                <div class="col-sm-12 col-lg-6 border border-primary show_later pt-2 pb-2">
                  <!-- Packet version -->
                  <div class="form-group p-0 m-1 row">
                    <label class="col-6" for="packet_version">Packet version</label>
                    <input type="text" id="packet_version" class="col-6 form-control form-control-sm" readonly>
                  </div>
                </div>
              </div>

              <!-- METI Live -->
              <div class="tab-pane fade" id="pills-live" role="tabpanel" aria-labelledby="pills-live-tab">
                <div class="col-sm-12 col-lg-6 border border-primary show_later pt-2 pb-2">
                  <!-- Enable METI Live Data Transmit -->
                  <div class="input-group p-0 m-1 row">
                    <div class="input-group-prepend">
                      <div class="input-group-text">
                        <input type="checkbox" id="sel_en">
                      </div>
                    </div>
                    <label type="text" style="color:#007bff; font-weight: 600;" class="form-control">Enable
                      METI Live Data Transmission</label>
                  </div>
                  <div class="live_settings">
                    <!-- URL -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-5" for="sel_url">URL/Server IP</label>
                      <input type="text" id="sel_url" name="sel_url" class="col-7 form-control form-control-sm"
                        data-validation-engine="validate[required], maxSize[32]">
                    </div>

                    <!-- Port -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-5" for="sel_port">Port</label>
                      <input type="text" id="sel_port" name="sel_port" value="80"
                        class="col-7 form-control form-control-sm"
                        data-validation-engine="validate[required, custom[integer], min[1], max[9999]">
                    </div>

                    <!-- Transmit interval -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-5" for="sel_interval">Tx interval</label>
                      <select class="col-7 form-control form-control-sm" id="sel_interval" name="sel_interval">
                      </select>
                    </div>
                  </div>
                </div>
              </div>
              <!-- MQTT -->
              <div class="tab-pane fade" id="pills-mqtt" role="tabpanel" aria-labelledby="pills-mqtt-tab">
                <div class="col-sm-12 col-lg-6 border border-primary show_later pt-2 pb-2">
                  <!-- Enable MQTT -->
                  <div class="input-group p-0 m-1 row">
                    <div class="input-group-prepend">
                      <div class="input-group-text">
                        <input type="checkbox" id="mqtt_enabled">
                      </div>
                    </div>
                    <label type="text" style="color:#007bff; font-weight: 600;" class="form-control">Enable
                      MQTT</label>
                  </div>

                  <div class="mqtt_settings">
                    <!-- Server -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-6" for="sel_server">Server</label>
                      <input type="text" id="sel_server" name="sel_server" class="col-6 form-control form-control-sm"
                        data-validation-engine="validate[required], maxSize[128]">
                    </div>

                    <!-- Client ID -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-6" for="sel_clientId">Client ID</label>
                      <input type="text" id="sel_clientId" name="sel_clientId"
                        class="col-6 form-control form-control-sm" readonly>
                    </div>

                    <!-- MQTT Server Username -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-6" for="sel_username">Username</label>
                      <input type="text" id="sel_username" name="sel_username"
                        class="col-6 form-control form-control-sm"
                        data-validation-engine="validate[required], maxSize[24]">
                    </div>

                    <!-- MQTT Password -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-6" for="sel_password">Password</label>
                      <input type="password" id="sel_password" name="sel_password" value="test_pw"
                        class="col-6 form-control form-control-sm"
                        data-validation-engine="validate[required] maxSize[24]">
                    </div>

                    <!-- MQTT Port -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-6" for="sel_port1">Port</label>
                      <input type="text" id="sel_port1" name="sel_port1" value="1883"
                        class="col-6 form-control form-control-sm"
                        data-validation-engine="validate[required, custom[integer], min[1], max[65535]">
                    </div>

                    <!-- Keep Alive -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-6" for="sel_keep_alive">Keep Alive (Seconds)</label>
                      <select class="col-6 form-control form-control-sm" id="sel_keep_alive" name="sel_keep_alive"
                        size="1">
                      </select>
                      <!-- <input type="text" id="sel_keep_alive" name="sel_keep_alive" value=600
                                                    class="col-6 form-control form-control-sm"
                                                    data-validation-engine="validate[required] custom[integer], min[0], max[900]"> -->
                    </div>

                    <!-- QOS -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-6" for="sel_qos">QOS</label>
                      <select class="col-6 form-control form-control-sm" id="sel_qos" name="sel_qos" size="1">
                      </select>
                      <!-- <input type="text" id="sel_qos" name="sel_qos" value="2"
                                                    class="col-6 form-control form-control-sm"
                                                    data-validation-engine="validate[required] custom[integer], min[0], max[2]"> -->
                    </div>

                    <!-- Publish interval -->
                    <div class="form-group p-0 m-1 row">
                      <label class="col-6" for="sel_pi">Publish interval</label>
                      <select class="col-6 form-control form-control-sm" id="sel_pi" name="sel_pi" size="1">
                      </select>
                    </div>
                  </div>
                </div>
              </div>
            </div>

            <div class="col-sm-12 col-lg-8 form-group row mt-1 show_later">
              <div class="col-sm-0 col-lg-3"></div>
              <button type="button" id="button_cancel"
                class="btn btn-warning col-sm-6 col-lg-3 ml-2 mr-2">Cancel</button>
              <button type="button" id="button_save" class="btn btn-success col-sm-6 col-lg-3 ml-2 mr-2">Save</button>
              <div class="col-sm-0 col-lg-3"></div>
            </div>
          </form>
        </main>
      </div>
    </div>
</body>

<footer class="page-footer font-small blue pt-4">
  <div w3-include-html="footer.html"></div>
</footer>

</html>

<script>
  w3IncludeHTML();

  $(document).ready(function () {
    $("#main_body").css("visibility", "visible");
    var cmd_list;

    setupSelects();

    function setupSelects() {
      //publish interval, remove 15, 30 in production
      dataArray = [15, 30, 60, 120, 300, 900, 1800, 3600]
      for (idx = 0; idx < dataArray.length; idx++) {
        var opt = $('<option></option>')
          .val(dataArray[idx])
          .addClass('dropdown-item')
          .addClass('dd-item')
          .text(dataArray[idx] + ' secs');

        $("#sel_interval").append(opt);
      }

      //MQTT keep alive
      dataArray = [30, 60, 120, 180, 300, 600]
      for (idx = 0; idx < dataArray.length; idx++) {
        var opt = $('<option></option>')
          .val(dataArray[idx])
          .addClass('dropdown-item')
          .addClass('dd-item')
          .text(dataArray[idx] + ' secs');

        $("#sel_keep_alive").append(opt);
      }

      //MQTT QOS (Quality of Service)
      dataArray = [0, 1, 2]
      for (idx = 0; idx < dataArray.length; idx++) {
        var opt = $('<option></option>')
          .val(dataArray[idx])
          .addClass('dropdown-item')
          .addClass('dd-item')
          .text(dataArray[idx]);

        $("#sel_qos").append(opt);
      }

      //MQTT publish interval
      dataArray = [30, 60, 120, 300, 900, 1800, 3600]
      for (idx = 0; idx < dataArray.length; idx++) {
        var opt = $('<option></option>')
          .val(dataArray[idx])
          .addClass('dropdown-item')
          .addClass('dd-item')
          .text(dataArray[idx] + ' secs');

        $("#sel_pi").append(opt);
      }
    }

    $("#button_cancel").on("click", function () {
      document.location.href = "index.html";
    });

    $("#button_save").on("click", function () {
      if ($("#formID").validationEngine('validate')) {
        var r = confirm("Save Device configuration?");
        if (r == true) {
          save_config();
        }
      }
    });

    function save_config() {
      var debug = 0;

      g_dev_comm_db.live.en = $("#sel_en").is(":checked");
      g_dev_comm_db.live.url = $("#sel_url").val();
      g_dev_comm_db.live.port = $("#sel_port").val();
      g_dev_comm_db.live.tx_interval = $("#sel_interval").val();

      g_dev_comm_db.mqtt.enabled = $("#mqtt_enabled").is(":checked");
      g_dev_comm_db.mqtt.server = $("#sel_server").val();
      g_dev_comm_db.mqtt.port = $("#sel_port1").val();
      g_dev_comm_db.mqtt.ka = $("#sel_keep_alive").val();
      g_dev_comm_db.mqtt.un = $("#sel_username").val();
      g_dev_comm_db.mqtt.pw = $("#sel_password").val();
      g_dev_comm_db.mqtt.qos = $("#sel_qos").val();
      g_dev_comm_db.mqtt.pi = $("#sel_pi").val();

      var url = "/saveDevCommConfig";
      if (LOCAL_HOST == true) {
        url = "http://localhost/play/index.php/quickIoT/save_dev_comm_config";
      }

      var type = 'POST';
      var data = {
        dev_comm_config: JSON.stringify(g_dev_comm_db),
        device_mode: 0
      };

      $.ajax({
        url: url,
        type: type,
        data: data,
        success: function (response) {
          if (debug == 1) {
            console.log(response);
          }
          else {
            // console.log(js_response);
            var result = response.result;

            if (result == 1) {
              alert(response.message);
            }
            else if (result == 0) {
              alert(response.message);
            }
          }
        },
        error: function (jqXHR, exception, response) {
          alert('POST Error!');
        }
      });
    }

    $("#sel_en").on("click", function () {
      enable_disable();
    });

    $("#mqtt_enabled").on("click", function () {
      enable_disable_mqtt();
    });

    function enable_disable() {
      if ($('#sel_en').is(":checked") == true) {
        $(".live_settings :input").attr("disabled", false);
      } else {
        $(".live_settings :input").attr("disabled", true);
      }
    }

    function enable_disable_mqtt() {
      if ($('#mqtt_enabled').is(":checked") == true) {
        $(".mqtt_settings :input").attr("disabled", false);
      } else {
        $(".mqtt_settings :input").attr("disabled", true);
      }
    }

    function displayDeviceParams() {
      //setup commands
      $(".show_later").css("visibility", "visible");
      //setup live parameters
      $("#packet_version").val(g_dev_comm_db.pkt_ver);

      $("#sel_url").val(g_dev_comm_db.live.url);
      $("#sel_port").val(g_dev_comm_db.live.port);
      $("#sel_en").prop("checked", g_dev_comm_db.live.en);

      // If read interval is not there in the list, choose 60 seconds
      if ($("#sel_interval option[value=" + g_dev_comm_db.live.tx_interval + "]").length == 0) {
        $("#sel_interval").val(60);
      } else {
        $("#sel_interval").val(g_dev_comm_db.live.tx_interval);
      }

      enable_disable();

      //MQTT related
      $('#mqtt_enabled').prop("checked", g_dev_comm_db.mqtt.enabled);
      $("#sel_server").val(g_dev_comm_db.mqtt.server);
      $("#sel_port1").val(g_dev_comm_db.mqtt.port);
      $("#sel_keep_alive").val(g_dev_comm_db.mqtt.ka);
      $("#sel_username").val(g_dev_comm_db.mqtt.un);
      $("#sel_password").val(g_dev_comm_db.mqtt.pw);
      $("#sel_qos").val(g_dev_comm_db.mqtt.qos);
      $("#sel_topic_pw").val(g_dev_comm_db.mqtt.t_pw);

      // If read interval is not there in the list, choose 60 seconds
      if ($("#sel_pi option[value=" + g_dev_comm_db.mqtt.pi + "]").length == 0) {
        $("#sel_pi").val(60);
      } else {
        $("#sel_pi").val(g_dev_comm_db.mqtt.pi);
      }

      enable_disable_mqtt();

      if (g_dev_comm_db.enabled == false) {
        $("#registration_status").css('visibility', 'visible');
        $("#button_save").attr("disabled", "disabled");
      }
    }

    function noSensorData(response) {
      console.log("POST Error...")
    }

    function updateDevicesParams(response) {
      $("#sel_clientId").val(response.dev_id);
    }
    //********* Call all start up functions after this line *******//

    setTimeout(function () {
      getDeviceParams(updateDevicesParams, noSensorData);
    }, 500);

    setTimeout(function () {
      readDevCommConfigFromFS(displayDeviceParams);
    }, 1000);

    $("#formID").validationEngine('attach',
      {
        validateNonVisibleFields: true,
        autoPositionUpdate: true
      });
  });

</script>